
<?php
/**
 * @file
 * Contains the Global Filter default argument plugin.
 */

/**
 * Default argument plugin to extract the global filter value set for this
 * contextual filter.
 */
class global_filter_plugin_argument_default_global_filter extends views_plugin_argument_default {

  function get_argument() {
    // $views_field_name equals either '<field_name>_value' or '<field_name>_tid'
    $views_field_name = $this->argument->field; // or real_field ?
    $exception_value  = $this->argument->options['exception']['value']; // e.g. 'all'
    $_ = strrpos($views_field_name, '_');
    if ($_) {
      $field_name = drupal_substr($views_field_name, 0, $_);
      if (global_filter_exists($field_name)) {
        $arg = empty($_SESSION[$field_name]) ? $exception_value : $_SESSION[$field_name];
        $views_type = drupal_substr($views_field_name, $_ + 1);
        if ($views_type == 'tid' && $arg != $exception_value) {
          // Return all children of the selected parent term.
          // Note this requires the user to tick "Allow multiple values" under
          // after expanding the "More" field set on the Contextual Filter
          // configuration panel. If not ticked on the parent tid will be
          // passed.
          $tids = array_keys(taxonomy_get_children($arg));
          return empty($tids) ? $arg : ("$arg+" . implode('+', $tids));
        }
        return $arg;
      }
      $view_name = empty($this->view->human_name) ? $this->view->name : $this->view->human_name;
      drupal_set_message(t('The view %view uses the global filter %name as the default contextual filter argument. However there is no associated <strong>Global Filter block</strong> for %name. Please configure a global filter <a href="/admin/structure/block">here</a> or remove this contextual filter default argument from the view.', array(
        '%view' => $view_name, '%name' => $field_name)), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('The contextual argument %name cannot be used as a global filter.', array(
        '%name' => $views_full_name)), 'error', FALSE);
    }
    return $exception_value;
  }
}